(********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Programm: Main
 * Datei: Main.fun
 * Autor: Administrator
 * Erstellt: 28. April 2021
 ********************************************************************
 * Funktionen und Funktionsblcke des Programmes Main
 ********************************************************************)

FUNCTION_BLOCK FB_HOLDX_R2 (* *) (*$GROUP=Anwender*)
	VAR_INPUT
		timSignalDauer: 	TIME;
		timTelegramPause: 	TIME;
		iAnzHoldX: 			INT;
		aHoldX_Command: 	ARRAY[1..30] OF tHoldXCommand;
		xBluetoothEin: 		BOOL;
		xSetDateTime:		BOOL;
		usiJahr:			USINT;
		usiMonat:			USINT;
		usiTag:				USINT;
		usiStunde:			USINT;
		usiMinute:			USINT;
		xSeriellDataIn:		BOOL;
		xInClock:			BOOL;	
	END_VAR
	VAR_OUTPUT
		dwHoldX_SafeOK:		DWORD;
		dwHoldX_LockOK:		DWORD;
		iErrorCode:			INT;
		iErrorHoldX:		INT;
		xSeriellDataOut:	BOOL;	
		xClockOut:			BOOL;
	END_VAR	
	VAR
		(* Gemeinsame Variablen Ein- und Ausgang *)	
		i:						INT;
	
		(* Variablen Eingangsdaten & Status Auswertung *)
		TOF_ClockNeu:				TOF;
		iCaseOutSwitch:				INT;
		F_TRIG_ClockIn:				F_TRIG;
		iAnzSigInt:					INT;
		aInfoBitOld:				ARRAY[0..43] OF BOOL;
		TON_KommunikationOK:		TON;
		F_TRIG_DatenAusgabe:		F_TRIG;
		aInfoBit:					ARRAY[0..43] OF BOOL;
		TON_ClockNeu:				TON;
		R_TRIG_DatenAusgabe:		R_TRIG;
		iCaseOutSwitchOld:			INT;
		aSafeOK:					ARRAY[1..30] OF BOOL;
		aLockOK:					ARRAY[1..30] OF BOOL;
		dwMaskeIn:					DWORD;	
	
		(* Variablen Ausgangsdaten & Befehle *)
		aTuerAnsteuer:				ARRAY[1..30] OF BOOL;
		aDatumUhrzeit:				ARRAY[1..27] OF BOOL;
		aRastkraft:					ARRAY[1..32] OF BOOL;
		iAnzahlHolX:				INT;
		xAlleZu:					BOOL;
		xAlleAuf:					BOOL;
		xTakt:						BOOL;
		xAlleAusgabeAktiv:			BOOL;
		xIndividualAusgabeAktiv:	BOOL;
		R_TRIG_ClockOut:			R_TRIG;
		F_TRIG_ClockOut:			F_TRIG;
		TOF_AusgabeAktiv:			TOF;
		iStep:						INT;
		i2:							INT;
		TOF_Takt:					TOF;
		R_TRIG_Freq:				R_TRIG;
		TP_Takt: TP;
		xBluetoothChange:			BOOL;
		xBluetoothOld:				BOOL;
		R_TRIG_Bluetooth: 			R_TRIG;
		F_TRIG_Bluetooth: 			F_TRIG;
		xBluetootAusgabe: 			BOOL;
		xDatumUhrzeitAusgabe: 		BOOL;
		R_TRIG_SetTime: 			R_TRIG;
		xSetTime_Store: 			BOOL;
		xRastkraftAusgabe50N: 		BOOL;
		xRastkraft50N_Store:		BOOL;
		iCountLogger: 				INT;
		xLoggerAktiv:				BOOL;
		xRastkraftAusgabe30N: 		BOOL;
		xRastkraft30N_Store: 		BOOL;
		xRastkraftAusgabe0N: 		BOOL;
		xRastkraft0N_Store: 		BOOL;
		dwMaskeOut: 				DWORD;
		dwRastkraft0N: 				DWORD;
		dwRastkraft0N_Old: 			DWORD;
		dwRastkraft30N_Old:			DWORD;
		dwRastkraft30N: 			DWORD;
		dwRastkraft50N_Old: 		DWORD;
		dwRastkraft50N: 			DWORD;
		R_TRIG_Rastkraft0N: 		R_TRIG;
		R_TRIG_Rastkraft30N: 		R_TRIG;
		R_TRIG_Rastkraft50N: 		R_TRIG;	
	
		iTestCommand: INT;
		xFehlerDatumUhrzeit: BOOL;
		xTestError:BOOL;
	END_VAR

END_FUNCTION_BLOCK
(* Anmerkung zum Telegramm 

	==> Der Master ist immer der letzte im Telegramm!!!*)

(* Anmerkung zu Zeiten

	HOLDX Standard Zeiten sind:
	
		90ms	Telegrammpause
		60ms	Signal
*)	
	
	
